Version 2.2 build 1919 *FINAL*
fixed: connecting to implicit ssl port without negotiating ssl will cause the connection to stay at there forever
fixed: now the explicit SSL is compatible with WS_FTP Pro
Version 2.2 build 1901
changed: IMPORTANT FOR EXTERNAL SCRIPT USERS , now the delete access over unfinished files is disabled if any script is installed
Version 2.2 build 1895
fixed: current filesize variable is not cleared to 0 on DELE command if the file is not found
fixed: creation date of directories in dir-dupe db were all incorrect
fixed: STOR command fails on WIN98 machines since v2.2 build 1860-1889
Version 2.2 build 1889
added: ALLOW_MULTI_APPEND option in raidenftpd.ini , default is disabled (0) , if you enable it people can resume upload on the same file for multiple times
fixed: sending some kind of filepath could damage the memory structure within the program
changed: default adduser_level is set to 3 (guest) now
Version 2.2 build 1875
changed: EVALUATION REMINDER (added in build.1844) is removed
changed: site wkup,wkdn,gpwu,gpwd,mndn,mnup,gpmd,gpmu commands are now 'per server' (was shared if you have multiple servers)
         note , you must at least upload/download a file to refresh these info.
Version 2.2 build 1860
fixed: STOR (upload command) no logner locks any file 
fixed: dir size in directory listing shows '0' if dir is bigger than 2g bytes
fixed: resuming for multiple times on the same file will gain too much credits 
Version 2.2 build 1844
changed: full installation pack is now only 3.x mb big , pictures files are moved to online web server
changed: outbound bandwidth restriction now also works for low speed users
changed: allowing multiple connections to append on the same file
fixed: sending 'site addip user user@ip' , will damage the IP file
fixed: APPE command by cuteftp pro sometimes hangs
added: new EVALUATION REMINDER after 48 hours of execution (only pops up in trial version)
Version 2.2 build 1835
added: a new button to QUIT the program immediatelly in the nag window
added: now you can use GUI to add user's (%S) or group's (%g) variable in vfs editor and it will automatically make user's or groups sub dirs for you
fixed: virtual path displayed in 150 opening.... message was wrong when using some SSL clients
fixed: memory buffer overrun problem in site urlget command
changed: updated japanese help docs + 3 new help files
Version 2.2 build 1829
fixed: when running program without a server started , the logon restriction window will crash the program
Version 2.2 build 1828
added: logon time restriction precision is upgraded , now it is capable of having different settings for each day in a week
added: exception reason for data connection (usually caused by firewall)
added: new variables %[ %] %, FTP server's normal port , implicit ssl port and explicit ssl port
fixed: tab ordering for many dialogs
Version 2.2 build 1808
added: a reset button in users editor , for you to reset all fields to default values quickly
added: window's opacity value in menu-preference , only works in win2000,xp
fixed: site chmod command is showing physical path in the response message when you are changing owner for a dir
Version 2.2 build 1801
fixed: SFV counter was not working completely in v2.2 build 1761
Version 2.2 build 1761
added: new option in raidenftpd.ini , ENABLE_PSWD_VAR , set to 1 to enable %P variable for non-anonymous users
fixed: a possible ssl connect crashing fix
fixed: SECURITY FIX , using #sudo command in 3rd party script could lead non-root users become root users
fixed: SECURITY FIX , when you chmod (change mode) on a path and making it read only , after you enter that path you can still write files if the parent permission allows you to write inside it
Version 2.2 build 1749
added: built-in LZH file type verification , note : only triggered when there is no .sfv file uploaded
added: new logon time restriction + GUI (from user editor) which allows you to disable user's login attemp during some hours of a day
added: when an user is not allowed to login during some hours , if he logged in before that time , he will still be kicked
added: the server will automatically kick all users (except root level users) when the site is closed by scheduler event
fixed: could not perform 'site chgrp' for a disabled user
fixed: onEveryDay event is not triggered if you have no scheduler task at all
Version 2.2 build 1725
changed: if the user account belongs to 'sitebot' group , it will display message files in the old '230-' style
         note : this only acts like this in the REGISTERed version of RaidenFTPD
changed: FATAL ERROR popup for no-IP is changed to GUI warning message 
Version 2.2 build 1707
changed: Raiden LOG Analyzer version up , v2.1 now
fixed: Eggdrop client can't work on Windows .NET server
fixed: Server port is closed after a save/reload in the server editor under Windows 2000 SP3 platforms
fixed: PORT availability testing feature doesn't work for Windows .NET server
fixed: raidenftpd.exe will crash if you click edit vfs button when you have no running ftpd server configured
fixed: server port changes is not effective if you save your ftpd but did not update , and then goto GUI to reload it
Version 2.2 build 1700
fixed: OPTS UTF8 response message from build 1677-1699 causes IE6 unable to process some dir names , it is disabled until it is fixed
fixed: vfs editor menu item : save as group's vfs file dialog won't display groups in multi groups format
Version 2.2 build 1699
added: 96 new GUI warning messages to tell you why local listen (PASV) / remote connection (PORT) attempt is aborted
added: 2 new menu items in VFS editor for you to add user's or group's own vfs files easily
Version 2.2 build 1677
fixed: command response for OPTS UTF8 ON isn't correctly displayed
fixed: Mp3Info displaying function causes an exception if the YEAR field is all empty
fixed: missing shortcuts in setup.exe for RaidenFTPD LOG Analyzer & Service Installer
added: identification for Internet Explorer is enhanced
Version 2.2 build 1644
fixed: SFV counter is always zero in v2.2 build 1638
fixed: pre-welcome screen doesn't work for non-registered version
Version 2.2 build 1638
added: built-in RAR 3.0 (http://www.rarlab.com/) file type verification , note : only triggered when there is no .sfv file uploaded
added: ZIP_CHK option is now also effective to .rar files
changed: message file displaying code had been re-written , now it's also 10 times faster (when displaying big msg files)
changed: OpenSSL update , updated to latest bug fixes version of OpenSSL 0.97 beta 3
changed: the hide delay for START_MINIMIZE=2 option is changed to 30 seconds (was 10 seconds) 
changed: if the user's host name is a local hostname (LAN) , the IP is written to the last-on information instead of writing domain name
fixed: running site undupe on a file in offline db will cause the server to respond nothing
fixed: now site commands are accepted in both upper and lower cases
Version 2.2 build 1599
fixed: new rftpdservice.exe , fixes windows xp keep alive problem
fixed: better code to re-create tray icon when the taksbar is created
fixed: the ask:// interface for external site command doesn't work properly (#sudo site cmd doesn't work)
fixed: the GUI won't allow you to add empty IP to the extra ip now
added: new GUI dialog box (under menu-setup) for you to setup server downloading restrictions
Version 2.2 build 1567
fixed: compatible with Windows.NET server platform now
fixed: Directory maybe locked if user is trying to LIST a hidden directory when the server is set to hide this dirs
added: ask:// interface is supported in site command dispatcher (only) , read : http://www.raidenftpd.com/kb/kb000000020.html
added: %M variable (file size) is now also available after a DELE command
added: inbound/outbound throttle restriction values will be saved/reloaded after restart of raidenftpd.exe
added: detailed error message (reasons) for server port create/listen failure
changed: new Bcg library v5.90 (bcgcb59.dll)
changed: server socket listening option parameter
Version 2.2 build 1533
fixed: character length of multi groups names is expanded from 64 to 256
Version 2.2 build 1525
added: now the server's uptime variable 'u' , will also display the DAYS information
added: a three seconds delay for each denied (by download restriction) download attempt
added: brand new simplified chinese interface and correct terms
fixed: a possible .raidenftpd.acl damaging problem
fixed: eggdrop client won't be disabled after you changed the advanced option to false in *.ftpd file without restarting the program
fixed: the show statistics command in simplified chinese version displays in traditional chinese 
fixed: if you change server port without restarting raidenftpd.exe , the SSL may not work later
fixed: the ssl pasv ip is not updated if your server ip changes by reloading *.ftpd file
fixed: SSL ghost connections wouldn't be kicked , stopped at 'SDNT *...' internal command
fixed: denied connections might not be removed if they keep sending dummy commands (the commands would not be executed but still a waste of server resource)
fixed: socket resource is not freed properly if the client is denied by anti-hammer , or denied when the server is closed
Version 2.2 build 1483
fixed: failed connections won't be kicked (timeout) if the connection is made from ftp bouncer
fixed: IP ban is not effective , if the user has the flag 'Disable IP Checking'
Version 2.2 build 1479
added: new password type (value=7) , 'Any Password' , if you set an user account with this option the user can enter anything as password to login his account
fixed: now the IP BAN list will be valid even if you didn't enable IP-Checking
fixed: user's origin IP is not logged into 'laston.dat' if the user's IP can not be mapped into a domain name
fixed: onFileUploaded event is triggered before the internal 'AddDupeFile' procedure , which caused external script unable to remove dupe file by this event
fixed: onZipUploaded event was not triggered for ask:// interface in some cases
Version 2.2 build 1456
fixed: USER/PASS response message changes to allow IE6 to popup a login dialog if the server does not allow anonymous login
fixed: you could not enter a domina name in the server IP addr. field in the server editor (would not be saved)
fixed: you could not enter a domina name in the first page of step by step setup wizard
added: added ftp command HELP (same as site help)
added: supports for IE6's SITE CHMOD (changing file modes by IE6)
added: supports for IE6's OPTS UTF8 ON command (url encoding/decoding for non-english characters)
added: a quick "EXIT" button in the user's editor
Version 2.2 build 1444
added: the creator of accounts is added to the end of account creation info
added: German GUI menu , German string resources are added
fixed: when your connection drops non-gracefully , your uploaded file is not checked , when you upload the next file in the .sfv file the previous file is renamed to .bad but not removed from dupe-db
Version 2.2 build 1425
added: 20 new string translated into japanese
added: now when you rename an user via GUI , the IP allowing file is also updated
added: user's account creation time is now added to site unfo , note: only newly created account after you change to this build
fixed: when you delete an user by GUI , the system generates a temp IP file but did not remove it
fixed: user's last-on information will not be displayed if you are typing site unfo to see yourself
Version 2.2 build 1411
fixed: when updating server_ip for dynamic IP host name , SSL passive IP is not updated
fixed: when you initialize the vfs editor from an existing vfs file and if the first entry is the root entry , you may encounter a problem
added: new field to the sitenuke.log file , new format is filename:size:owner
added: RaidenLog Analyzer 2 is now built into the RaidenFTPD package
added: "530 Explicit SSL/TLS must be enforced" error message when user connects to explicit ssl port without using explicit ssl
Version 2.2 build 1390
fixed: dir listing on large directory is 10 times faster now
fixed: OUTLIMIT_RECORD was erased when quitting program
fixed: OpenSSL library updates to 0.97b2 , you can remove old ssleay32.dll and libeay32.dll now
Version 2.2 build 1382
fixed: when user had finished uploading/downloading , if he didn't perform any other commands , he was still included in the dl/ul user counts
fixed: if you are using dyn_ip_host , when you save and exit from server editor dialog , the IP may no longer work
fixed: if you are using dyn_ip_host , when you reload your server , the IP may no longer work
fixed: OUTLIMIT_RECORD , INLIMIT_RECORD were not updated to 0/0 unless people upload or download when the time is up
fixed: a DBCS path with '\' character replacement bug
added: new option value for MAX_NO_RATIO_USERS_PER_GROUP in ./VirtualFS/[ServerName]/restriction.dat , 'n' , if you set it to z , there is no no ration user allowed to be added via site command
Version 2.2 build 1381
fixed: our mistake that makes build 1380 unable to delete a file via ftp
Version 2.2 build 1380
fixed: a possible memory overrun error while the client is sending dummy PASV continuously without actual data connection
Version 2.2 build 1379
fixed: when using SITE MSG , the message content will not be displayed in site who
fixed: Vfs editor root dir identification bug
Version 2.2 build 1377
added: new send msg method , now the ftp voyager client will pop up a window if sysop sends a msg to the client
added: different servermails.dat for each .ftpd , placed under ./VirtualFS/[SERVER NAME]/servermails.dat
added: new sysop mails viewer (menu item) , can read msgs from users and reply to them
added: new tray icon if you have messages from ftp users
fixed: better vfs setup procedure ..
Version 2.2 build 1369
fixed: new dir counter is displayed incorrectly in 'site new' command
fixed: VFS editor problem , unable to remember physical root dir location if you didn't use browse button
fixed: When accessing mp3 files with genre # 255 , it causes memory errors
changed : site add user grp ip1 ip2.... , now allowing up to 4 IPs
Version 2.2 build 1361
fixed: could not delete empty dir with '\' character at the end of dir name (usually chinese dir names)
added: new menu item : generate stats , to generate server(s) stats file
added: new license info line to show registered username / email (startup messages)
added: new last made directories data file under [raidenftpd dir]/VirtualFS/[server name]/newdir.dat
added: site new command now accepts argument for number of dirs to display , i.e. site new 5
changed: bcg control library dll update : to v5.84 , you can delete bcgcb583.dll now
Version 2.2 build 1351
fixed: bad sequence of REST/STOR commands could cause wrong credit value
Version 2.2 build 1345
added: full spanish help documents included
added: warning message when loading empty .ftpd file
added: automatically bring up the vfs editor if user is running a site without properly defined .vfs file
added: if the vfs editor is opened with an empty .vfs file , some default values will be set
fixed: vfs editor root dir recognizing problem for the first mount point
fixed: when loading an empty user file from user editor , the default values of all fields will be properly initialized
fixed: server won't load empty .ftpd file from startup list even if it's added now
Version 2.2 build 1322
added: #sudo command for output file of ask:// interface , see : http://www.raidenftpd.com/kb/kb000000014.html
added: new varaible , %/ = user's group , all groups will be displayed if user is in multi groups
fixed: eggdrop section events and site eggtalk didn't work for #sudo command for output file of ask:// interface
fixed: in .vfs files , now the virtual paths with or without trailing '/' character will both work
fixed: if you have DUPECHK_ALSO_CHK_DIR=1 , the dupe engine would only load directories names but not file names
Version 2.2 build 1309
added: site nuke log file : sitenuke.log will be written to the renamed directory , for future recovery
added: new file transfer restriction definition file ./VirtualFS/$SERVER_NAME/restriction.dat
[DL]
 MAX_DL_UNDER_ONE_UNAME=0~n , 0=no restriction , n=number of max downloading threads allowed under same user account
 MAX_DL_UNDER_ONE_GNAME=0~n , 0=no restriction , n=number of max downloading threads allowed under same group
 MAX_DL_UNDER_ONE_SERVER=0~n , 0=no restriction , n=number of max downloading threads allowed under the whole server
 MIN_UL_TO_INITIATE_DL_USER=0~n , 0=no restriction , n=number of minimal uploading threads to enable accounts under this username to download
 MIN_UL_TO_INITIATE_DL_GROUP=0~n , 0=no restriction , n=number of minimal uploading threads to enable accounts under this group to download
[SITE_ADDUSER]
 MAX_USERS_PER_GROUP=0~n , 0=no restriction , n=number of max user count that is allowed within a group , only effective to site adduser command performed by super level users , not effective in GUI or to root level users
 MAX_NO_RATIO_USERS_PER_GROUP=0~n , 0=no restriction , n=number of max no ratio user count within a group that is allowed , only effective to site adduser/chratio commands performed by super level users , not effective in GUI or to root level users
fixed: a bug in variable translation which will cause infinite loop
fixed: when using site nuke command , the multiplier token could not contain space chars between | (pipes)
changed: site chratio command can now also be performed by super level users , set the above MAX_NO_RATIO_USERS_PER_GROUP value to handle it correctly
Version 2.2 build 1285
added: online dupe-db scanning will also add directory names if you have DUPECHK_ALSO_CHK_DIR=1 (raidenftpd.ini)
added: user's last-online time is now logged in ./VirtualFS/SERVER_NAME/laston.dat and will be displayed in site unfo
added: user's last-online time is displayed in users editor dialog now
added: new gui items for 7 raidenftpd.ini options in the preference window
added: new site adduser arguments
 old : adduser [user] [password]
 old : adduser [user] [password] [groupname]
 new : adduser [user] [password] [groupname] [ip1] [ip2]
Version 2.2 build 1279
fixed: S/KEY password erasing problem in some cases
fixed: INLIMT and OUTLIMT erros in *.ftpd files which caused the traffic limitation unable to work
added: new user's file system permission mode : "use personal settings" instead of using *NIX permission systems , configure it in user's editor
Version 2.2 build 1267
fixed: bad sfv file compatibility enhancements
added: user's enabled/disabled field will be displayed in site unfo now
added: new site command : site uchanges / site uchanges clear , display last userfile changes
added: site command reference page updated
Version 2.2 build 1256
fixed: compatibility problem with MOVEit ssl ftp clients (http://www.stdnet.com/)
fixed: site chpass doesn't work if you are using s/key by default
fixed: main window is clipped sometimes when you restor GUI from tray icon
fixed: 3 memory leaks in ssl connections
added: tray icon context menu (right mouse click)
added: popup menu item in the screen log area , 'clear log view'
added: quick 'exit & save' button in vfs editor
added: quick 'save & reload & exit' button in server editor
Version 2.2 build 1249
added: site bufsize command , to adjust TCP WINDOW SIZE (4-64k bytes)
fixed: max user per IP was working incorrectly while using SSL connections
fixed: users were unable to login using the password specified if ADDUSER_PASSTYPE in raidenftpd.ini is set to s/key
fixed: ADDUSER_COMMENT in raidenftpd.ini was not effective since Version 2.2 build 1119
changed: if users are connecting via Internet Explorer 5-6 using anonymous accounts , the message feature is automatically disabled (it doesn't support it properly)
Version 2.2 build 1241
changed: icon in the ftp log window
changed: onFileUploaded event is triggered before raidenftpd updates user file (was after)
Version 2.2 build 1237
fixed: .raidenftpd.acl is not automatically removed if it's not in all 'lowercase' characters while deleting a directory
Version 2.2 build 1234
fixed: Mp3 ID3 tag parsing error in v2.2 build 1226
Version 2.2 build 1226
changed: OpenSSL library changes from v0.96b to v0.96d
fixed: Windows Commander 5.0x S/KEY compatibility
fixed: unable to RESUME UPLOAD from v2.2 build 1209-1226
fixed: server will now not load empty IP str as extra IPs even if you entered some empty IPs
Version 2.2 build 1221
fixed: a window clipping problem which will cause the server inaccessible
fixed: SSL data transfers speed up (about 10 times)
fixed: when user enters the wrong password using the S/KEY , the user's IP field is not logged in log file
fixed: when user closes connection while checking crc32 value , the crc32 checking is not terminated properly
fixed: when you start raidenftpd without clicking on the 1st server's icon and then click the button bar icons , it will point to wrong *.ftpd file
fixed: site chratio username <- without ratio value , will cause client to hang
fixed: internal chmod will not accept empty filename , '.' , '..' from now on
changed: now when you click minimize button the window will not be hidden (you have to click close button to hide it)
added: supports for AUTH TLS-P command
added: supports Windows Commander 5.0x one time password using hex password format
Version 2.2 build 1209
changed: SSL behavior (150 opening...) changes to match the requirement in 
         http://www.ietf.org/internet-drafts/draft-murray-auth-ftp-ssl-09.txt
added: full 64 bits addressing space support
added: supports file length > 4g bytes in directory listing
added: supports resume uploads/downloads on 4g bytes+ positions
fixed: bug in displaying directory size for . and .. directories
fixed: SSL is now compatible with ftps.exe from 
       http://bsdftpd-ssl.sc.ru/files/bsdftpd-ssl/packages/windows/sslftp-0.13-client-win-0.5.zip

-- 64 bit compatibility --
+------------------------+------------------+------------------+-----------+-----------+
|        Software        | Dir List(remote) | Dir List (local) | DL/RESUME | UL/RESUME |  
+------------------------+------------------+------------------+-----------+-----------|
+ Windows Commander 5.01 + YES              + YES              + YES/YES   + YES/YES   |
+------------------------+------------------+------------------+-----------+-----------|
+ FlashFXP 1.4.850       + YES              + YES              + YES/YES   + YES/YES   |
+------------------------+------------------+------------------+-----------+-----------|
+ C???FTP Pro 2.0        + YES              + YES              + NO/?      + NO/?      |
+------------------------+------------------+------------------+-----------+-----------|
+ Smartftp 1.0.968.1     + YES              + YES              + YES/YES   + YES/YES   | 
+------------------------+------------------+------------------+-----------+-----------+


Version 2.2 build 1166
fixed: sfv counter fix , for duplicated entries in .sfv files
Version 2.2 build 1159
added: onFileDeleted event to support ask:// interface , see : http://www.raidenftpd.com/kb/kb000000014.html
changed: SSL behavior changes for SmartFTP v1.0.968 , if you will be using it you have to upgrade to RaidenFTPD v2.2 build 1159
fixed: when performing site nuke , it will also kick people whose current directory is the same as the target directory
fixed: memory overrun for multiple groups users in some cases
Version 2.2 build 1146
added: now you can also put host name in SERVER_IP (you needed to put in DYN_IP_HOST)
fixed: site dnfo/race displays wrong total directory size if the sum of all filesizes is bigger than 4g bytes
fixed: now the server will not accept | character in username and group name , because it will cause some permission problems
Version 2.2 build 1119
added: FTP data inbound/outbound throttle system
added: new option in raidenftpd.ini , ADDUSER_PASSTYPE=0 (default password type , 0=normal , 2=s/key md4 , 3=s/key md5 , 4=s/key sha-1 , 5=force SSL)
added: new option in raidenftpd.ini , DUPECHK_CHK_FILE=1 , if set to 0 , when you upload a file , it will not be added to dupe-db , this is intented to be used with DIRECTORY NAME dupe checking
fixed: site urlget crashes server if URL is longer than 256 bytes and if the urlget FAILS
fixed: sending msg to ftp users when the user is gone offline will crash the server
changed: the filename can contain variables now when you include another msg file within message files
changed: GUI library version update , bcgcb582.dll
Version 2.2 build 1066
fixed: upload/download stats files would be damaged sometimes
fixed: VFS editor won't ask you to create any more path with '%' variables
fixed: SSL pasv IP will be forced to use default IP if you don't input anything as Server IP and turned Auto Choose IP off
fixed: Anti Hammering LOG format incosistency
fixed: .vfs file parsing bug for some more non-ascii characters
added: stats of 'bandwidth restriction for a period' will be saved into *.ftpd file and will be reloaded if you restart server
added: warning message box if Server IP is set to empty and Auto Choose IP is off
changed: hammering users are only displayed on screen now (not logged onto disk log)
Version 2.2 build 1041
added: Force SSL option in user editor (in the password type menu)
Version 2.2 build 1033
added: new license schema : machine id
Version 2.2 build 1029
changed: site move command now does not use 'COPY and DELETE' method , it changes to 'MOVE directly'
fixed: would not warn user if he is using PORT 0 as server primary port , which could not work
fixed: would not warn user if he sets same port to server both implicit and explicit SSL
fixed: could not rename an user in user editor
fixed: Japanese html help pages contain chinese char set identifier
fixed: GUI library version update , bcgcb581.dll
fixed: GUI error , if you don't click on the server icon first , the default user,vfs,ip files are set to default ones
fixed: GUI error , when the mouse cursor is on an user , sometimes the 'client type' field was displaying server's attribute
Version 2.2 build 1020
fixed: virtual file system configuration files parsing error , while the virtual path contains some chinese chars
Version 2.2 build 1019
fixed: SSL compatibility issue with FlashFXP with SSL beta version , if you are using FlashFXP w/ SSL with RaidenFTPD you must upgrade to this version
fixed: script timeout could not be disable in external site commands
fixed: user file maybe locked while calculating concurrent download/upload users count
fixed: an error that could cause 425 Server IP lost error
fixed: when using DBCS , you could not put any dir name with | in the lower byte of the characters
fixed: file handle not closed if user aborts resume uploading using APPE command
fixed: memory error when querying filesize on a not existed filename using SIZE command
fixed: SSL pasv socket memory leak
fixed: 100% CPU loading if there is no available data socket for SSL pasv sockets
fixed: Explicit SSL port resource was not freed after server quits
Version 2.2 build 1000
fixed: possible to use up ALL CPU POWER in some cases when using SSL
fixed: VFS editor dialog failed to remember physical root directory if you change it without saving
fixed: another memory error while performing site who/xwho
changed: script timeout value changed from 10 seconds to 30 seconds
added: new option in RaidenFTPD.ini , SCRIPT_TIMEOUT , if set to 0 , script execution is not restricted by timeout value
Version 2.2 build 965
added: new option in RaidenFTPD.ini , TRIGGER_SITEMOVE_FIRST , if set to1 , site move is triggered before RaidenFTPD is actually moving files
changed: ZIP library updated , was using XceedZip v4.1 , now upgraded to v4.5
changed: now ANY of the bouncer's IP BOUNCERIP in *.ftpd) , is excluded from ANTI-Hammering , HINT : also add your sitebot IP to the BOUNCERIP lists
fixed: in some cases , the site who command would crash (500 no parent object error)
fixed: in some cases , the site xwho command would crash (500 no parent object error)
fixed: when using directory name dupe checking , the dupe entry was not removed if you delete the directory
Version 2.2 build 956
fixed: SSL accept was not cleaned up if the connection SSL connection failed (will cause SSL port eventually down)
fixed: program to quit if field count in .vfs file is incorrect (more than the amount we need)
fixed: FILE HANDLE was not closed in some cases while the uploading is interrupted (which will cause unable to resume or delete over that file)
Version 2.2 build 944
fixed: transfer delay reduced with FTP clients that can not receive at 'HIGH SPEED' (means RaidenFTPD has always to wait for it)
fixed: server IP field in server editor dialog has incorrect length limit (CHINESE version only)
fixed: speed calculation in site who did not include STOU/APPE commands
fixed: Anti-Hammering protection would ban local IP 127.0.0.1
fixed: If client is using TLS (AUTH TLS) , the clear data channel is assumed now
fixed: site move event is not triggered , if the source directory can not be deleted (now using copy & delete) , it resolves a site-stat 'site pre not triggered' problem
changed: credit value is now floating point value (was integer)
added: AUTH TLS is added to the feature list
added: new variables including the following (for msg files and scripts to use)
%& number of online people downloading , evaluated on RETR/STOR/APPE commands
%( number of online people uploading , evaluated on RETR/STOR/APPE commands
%) number of logins downloading under this user name , evaluated on RETR/STOR/APPE commands
%_ number of logins uploading under this user name , evaluated on RETR/STOR/APPE commands
%| number of logins downloading under this group name , evaluated on RETR/STOR/APPE commands
%\ number of logins uploading under this group name , evaluated on RETR/STOR/APPE commands  
Version 2.2 build 923
fixed: IP editor dialog went wrong if you have no server running or if the server failed to load
fixed: onFilePreDownload event is not added in the *.ftpd file if you use wizard to generate your server
changed: when you are not using wizard to setup your own first server , it will also ask if you want to add it to startup list if you have no server running at all.
Version 2.2 build 916
added: Anti-Hammering(d.o.s) / GUI setup in the IP-Editor , note that there are some minimal value limitation to avoid too much overhead , the default value is to ban an IP for 120 seconds if an user connect from an IP for more than 10 times during 60 seconds
 * Note : ALL local IPs + Server IPs will *NOT* be evaluated by Anti-Hammer protection for compatibility reason
 * Note : Anti-Hammering works for Normal Server / SSL Server ports
fixed: some errors in the site help command
fixed: memory error while having empty value for 'eggOnPreCwd' event
fixed: SSL connection failure error on SLOW(or very busy) machine
fixed: memory leak when user disconnects in some cases
fixed: uninitialized ASCII data buffer pointer memory error
Version 2.2 build 891
fixed: 1 memory accessing problems that may cause program halts
fixed: an SSL ghost connection problem while using IglooFTP (if you close IglooFTP directly)
fixed: 2 small SSL related bugs
Version 2.2 build 870
fixed: when using REST+APPE to resume upload , it required X flag , now only requires W flag
fixed: default ftpd is not selected on your only .ftpd when you only have one server running
fixed: special support for IglooFTP Pro's SITE CHMOD command format
added: RaidenFTPD specific command 'XMD5' support , possible to calculate MD5 on the fly
           XMD5 "FileName" StartPos EndPos\r\n I.E. : XMD5 "XXX.ZIP" 0 1356
added: new option in RaidenFTPD.ini , DUPECHK_ALSO_CHK_DIR , set to 1 if you want dupe checker
       to check directory names also.
       * note that you still need dupe checker enabled
       * inclusion / exclusion list work with this new option
       * only works if online dupe check mode is used
Version 2.2 build 833
fixed: SSL ghost connection while using FTP Voyager to cancel a file transfer
fixed: user's icon returns to normal icon (non-ssl) when redrawing ftp server tree for ssl users
fixed: SSL doesn't work when using behind 3COM (and probably some other) routers
Version 2.2 build 821
fixed: unable to display server information in GUI if you only start implicit SSL but not explicit SSL
Version 2.2 build 812
fixed : Max connections per IP is not working if users are connected through a bouncer or SSL
fixed : RaidenFTPD was allowing you to create a file then cut the file transfer when quota exceeded
fixed : PROT C did not activate PORT command in SSL mode
Version 2.2 build 805
added : Explicit SSL support , works with 'SmartFTP' 'FTP Voyager' 'CuteFtp Pro' 'IglooFtp Pro'
added : support for 'MDTM YYYYMMDDHHMMSS filename' command for ftp client to set file date and time after uploads (require write access) , works with Ftp Voyager
added : support for 'LIST -T' , extended directory listing (works with FTP Voyager 9.0)
added : different ICON for users who connected via SSL
fixed : error while ftp client sends LIST with argument for 'single filename with space'
fixed : GUI error in the user edit dialog in chinese version
Version 2.2 build 750
changed: default message files language changed to 'English'
fixed : two mp3 genre strings were modified for compatibility reason
fixed : all tab ordering in all dialogs re-arranged
fixed : SSL data connection port range now also uses same setting as the server's one
fixed : all dialogs are verified again for better layout
fixed : problems when running SSL server on private IP address.
fixed : compatibility issue with FTP VOYAGER 9.0 when using SSL
added : new option - RENAME_BAD_FILE in raidenftpd.ini , set to 0 if you don't want bad files to be renamed to .bad
added : implicit SSL ftp server support
added : RaidenFTPD specific command 'SDNT' , to be used with built in RaidenTunnel/SSL bouncer
added : to be possible to identify if the user is from a RaidenTunnel/SSL bouncer in GUI
added : SSL port option in Server Editor dialog (only available in SSL licensed copies)
added : CuteFTP Pro 2 specific command 'XCRC' support , possible to calculate CRC32 on the fly
           XCRC "FileName" StartPos EndPos\r\n I.E. : XCRC "XXX.ZIP" 0 1356
Version 2.2 build 688
fixed: root level users / sitebot group users still get timed out by server timeout value
fixed: when deleting an user , his IPs were not removed from .allow file
fixed: site disable/enable command , super user couldn't disable/enable same group users (lower levels)
Version 2.2 build 686
fixed: 1 memory problem when you are starting a started *.ftpd file
fixed: internal timeout timer loaded for multiple times if you reload server configuration file
fixed: anti-deadlock on the machines without any IP (even for a short period of time)]
added: new option is RaidenFTPD.ini "TRIGGER_EXT_SCMD_FOR_INT_SCMD" , that means external site commands will be triggered even if the command was handled internally
Version 2.2 build 666
added: new built-in external site commands dispatcher , see: http://www.raidenftpd.com/kb/kb000000020.html
       (old onSiteCmd~onSiteCmd still works)
added: new attribute for the group name 'sitebot' , it has no timeout value now
added: new group name 'looklook' , it has the following special attribute
 - can browse into any DIR (accessible in VFS , not your physical directories)
 - can upload to any DIR if he has access to do so (normally if you allow this group to Write on a path)
 - can not delete anything , can not rename anything
 - can not execute site command
 - can not download anything unless it's a free file only
added: new group name 'fsmaster' , it has the following special attribute
 - full access READ/WRITE/DELETE/CWD/LIST to all items in virtual filesystem , without the need of being ROOT level
fixed: automatically clean up of UNKNOW : NOT YET , ghost connections
fixed: gave too much credit for resume uploads
fixed: for internal site command 'site user' it still triggers external site commands (waste of time)
fixed: RaidenFTPD to crash if the user has no root directory's messagebox is close after the user disconnects
fixed: does not even parse the virtual path if the CWD/RETR command contain '*' , '?' , ':' characters (better security)
changed: 3rd party script 'menionscript' de-supported
Version 2.2 build 598
fixed: high cpu loading while transfer huge file in ASCII mode under WindowsXP
fixed: high cpu loading while aborting file transfer in ASCII mode
Version 2.2 build 556
added: logon scripts support , see : http://www.raidenftpd.com/kb/kb000000018.html
added: new option in RaidenFTPD.ini , AUTO_FIX_SFV , if it is set to 1 , it will automatically fix bad .sfv file
added: new option in RaidenFTPD.ini , AUTO_DEL_GCID , if it is set to 1 , it will automatically delete *.gcid files in output dir (for script debugging , set it to 0)
fixed: unable to mount network drive provided by WebDrive (www.webdrive.com) under Win2000
fixed: one warning message box still pops up if you set WARNING_ON_NO_ROOT to 0
fixed: a line with one space char will be counted as one file in .sfv file
fixed: sfv file wouldn't be loaded if the .sfv file contains 0x1a character
fixed: onZipUploaded was triggered for bad zip files , when using ask:// instead of exec://
Version 2.2 build 505
changed: now you can't use site chmod to change mode for directory mount points (use vfs editor)
changed: updated help files (server options page)
added: new option to hide dir/files to users without read permission over those files/dir
fixed: in XTRA_IPS , it allowed you to put empty IPs and caused errors (,,,)
fixed: in XCLU_IPS , it allowed you to put empty IPs and caused errors (,,,)
fixed: under Win98/Me the image buttons are not transparent
Version 2.2 build 486
fixed: when you use site alup instead of site utop , the internal top list buffer may get messed up
changed: now external script is not triggered if the site command is handled internally by RaidenFTPD
added: now when you delete an user via GUI/site deluser , the user's IP allowing list were also deleted
added: new image button bar in the main window
added: 4 new options in *.ftpd file
EXCEPT_SITE_CMD_R=
EXCEPT_SITE_CMD_S=
EXCEPT_SITE_CMD_N=
EXCEPT_SITE_CMD_G=
now you can set which site command to be handled internally or sending it to external script (by user level)
you can also disable internal site command by simply adding them to these lines
Version 2.2 build 423
fixed: "insufficient privilege" spelling error
fixed: eggdrop client is now compatible with french ver. of eggdrop
added: right mouse button to copy text from GUI log window
added: new entry in raidenftpd.ini , DEF_NOCRED_LINE . default message for no credit error
added: new bitmap buttons in various GUI dialog boxes
Version 2.2 build 386
added: new option in RaidenFTPD.ini , ALLOW_P@SW=0 or 1 , to treat P@SW as PASV , for some bad routers
fixed: GUI to lock-up while the system has "0" IP
Version 2.2 build 377
fixed: current directory variables were not updated after CDUP
fixed: display error msg if source and target directories are the same (physical) when using site move
fixed: do not display error dialog when the site move command can not be finished
fixed: when using RNFR/RNTO to move files or directories , the operation can not success if source and target are on different drives
fixed: now the console window will not pop up if you are executing a program by built in scheduler
fixed: does not allow renaming root directory or performing site move under root directory
added: now the script execution time for "ask://" will be logged in screen/disk log
Version 2.2 build 356
fixed: exec:// event in raidenftpd.task would be executed for twice
fixed: possible to display nothing while the user IP is denied (remove the msg file or make it 0byte)
added: new RaidenServiceInstaller.exe/Rftpdservice.exe which support up to 3 instances of RaidenFTPD.exe
added: site sync d2m , when using mem-db , this command forces server to load user file from disk to mem-db
added: site sync m2d , when using mem-db , this command forces server to save mem-db to disk user file
added: updated site command help files
added: now the script execution time will be logged in screen/disk log
changed: site reload : does not reload mem-db automatically now , use site sync d2m instead
Version 2.2 build 340
fixed: user can not logout when he tries to logout for the second time (when running as service)
fixed: **SECURITY FIX** , annoucement delayed due to security reason , update now!
fixed: variable %% was not working properly
added: new RaidenFTPD.pid file which will be written to /Windwos/ directory , helps you to identify RaidenFTPD process ID
added: automatically create default.ftpd defaul.user , default.allow if they do not exist , for the first time setup users
added: ask for "add to startup list or not" when you are saving *.ftpd which was not listed in startup list
added: file:// , exec:// , ask:// now supports relative path (relative to RaidenFTPD path)
added: new RaidenFTPD service agent , to upgrade please stop/uninstall previously installed service first
changed: default file system mode changed to 764 for the first time setup users
Version 2.2 build 325
added: onFileUploaded event to supports ask:// interface
added: onZipUploaded event to supports ask:// interface
added: warning messages if you are using internal IP addresses as PASV IP
added: automatically add internal IP address to excluded IP when you new a *.ftpd via GUI
added: automatically add internal IP address to excluded IP when you use wizard to design *.ftpd
fixed: when using empty user file , the first user's password type was pointed to empty type
fixed: automatically ask for entering a new filename if you are saving *.ftpd from GUI without giving it a name first
fixed: GUI hangs up while opening a *.ftpd with no server running
Version 2.2 build 320
added: now you can ask the server to run certain commands by external programs , see : http://www.raidenftpd.com/kb/kb000000014.html
added: new event : onPreCwd , executed before the server returns the directory changed messages , also supports ask:// interface (http://www.raidenftpd.com/kb/kb000000014.html)
added: %G , %H variables now also work with onPreCwd event
Version 2.2 build 308
changed: now new directory info will not be added to 'site new' if the virtual path has the option "do not show activities in site who under this path"
added: new option in *.ftpd , ZIP_CHK under [FTPD] , 0=no , 1=yes (rename to .bad if error occurs) , 2=yes (delete bad zip directly)
Version 2.2 build 299
fixed: some site commands don't work in v2.2 build 291 (nuke/take/give)
fixed: when user deletes a file , the credit was removed but not multiplied by his ratio
fixed: site new's header line contains strange character
added: onDelDir event supports ask:// interface now
added: onFilePreDelete event supports ask:// interface now
Version 2.2 build 291
added: encrypted LOG option , create encrypted LOG files on the fly , using the machine's registration key (registered ver only)
added: new option : WARNING_ON_NO_ROOT in RaidenFTPD.ini , set to 0 to disable no root directory warning message upon login
added: new option : DISABLE_UD_TOPS in RaidenFTPD.ini , set to 1 to disable site utop/dtop , if you have more than 500 users you may want to disable it
added: new option : SHOW_DIR_SIZE_UNC in RaidenFTPD.ini , set to 1 to display directory size even if the path is under UNC , note : really slow
added: new variable %> , current file's CRC32 value , only available in onSfv*** events
added: new light speed memory user db , supports up to 25000+ user accounts
added: new option in *.ftpd under [FTPD] section , USE_MEM_DB=0 or 1 , set to 0 to use traditional user db and set to 1 to use mem-db
added: site reload also reload RaidenFTPD.ini
fixed: some extractable ZIP files (while having minor errors) wouldn't get an onZipUploaded event
fixed: display "Account disabled" message if user account is disabled
fixed: file handle not closed properly problem while listing file with hidden attribute
fixed: server's 'do not check IP' does not work properly if the user's account is set to 'check IP'
fixed: network UNC path locking problem (can not delete after you enter that UNC)
fixed: program will hang if the *.ftpd file listed in raidenftpd.startup is missing
fixed: when using CuteFTP/Windows Commander to download a 0 byte file , a error msg will be reported
chanegd: now DEF_LISTED_LINE allows variable translation (do not put more than 80 chars)
Version 2.2 build 221
fixed: a buffer overflow denial of service attack , see :
Version 2.2 build 209
fixed: one wrong variable in one .msg file
changed: onFilePreUpload event moved to a prior place before the file is written to the disk
added: onFilePreDownload event , also supports ask:// interface
added: new warning messages for PORT/PASV error 
Version 2.2 build 201
added: new event trigger method "ask://" . interact with external scripts
added: ask:// event handler for onUserLogin , onNewDir , onFilePreUpload events
            get sdk pack at : http://www.raidenftpd.com/download/asksdk.zip
Version 2.2 build 181
added: new site command 'site xwho' , display user's info and his domain name , for root only
added: new quick help topic buttons on server editor dialog
added: new option in raidenftpd.ini , DEF_LISTED_LINE under [DEFAULTS] , default is "Transfer finished successfully. Data connection closed"
added: new option in raidenftpd.ini , 
fixed: site dnfo layout bug
Version 2.2 build 168
fixed: added 3 seconds delay between onSfvSuccess and OnSfvComplete
fixed: added anti-locking while processing large amount of directory size measurement
Version 2.2 build 166
fixed: self kick didn't work for multi-group users and normal level users
fixed: vfs editor , group's combo box was displaying multi-groups
fixed: automatically bind to all local IP addresses if using  DYN_IP_HOST
added: new variable , %^ , the user's current directory (physical path)
added: new option SHOW_DIR_SIZE , in raidenftpd.ini , set to 1 and the dir size will be displayed while doing a directory listing , however the speed will be slower
added: new option TRIGGER_EVENT_UNDER_HIDDEN_PATH , in raidenftpd.ini , set to 1 and the event trigger will occur even if you are under virtual paths with hiding in site who attribute
Version 2.2 build 154
changed: DLL version checking removed
added: russian help files included
Version 2.2 build 150
changed: STOR reject code changed from 426 to 533
fixed: auto abort for PASV loop while server lost its IP address
added: x-dupe mode 2,3,4 , works with flashfxp 1.3 build 784+
added: system DLL version check , prevent you from using OLD dll with RaidenFTPD
added: supports for Server with IP changing at running time , new option in *.ftpd , DYN_IP_HOST under [FTPD] , see http://www.raidenftpd.com/en/raiden-ftpd-doc/howto-setup-ip.html
Version 2.2 build 133
added: new VFS option , Do not count stats under this path
added: new VFS option , Do not show activities in site who under this path
added: new VFS option , Force free download under this path
added: new parameter support for directory listing , LIST -CF
added: new variable '%=' , the long file name which the client just accessed (without path)
changed: variable '%+' , now output will be formatted into Upper case
fixed: max allowed IPs for each user is expanded to 512 rows (was 256 and buggy)
fixed: raidenftpd.ini bug , in ADDUSER_COMMENT
Version 2.2 build 115
added: new option in RaidenFTPD.ini , AUTO_USE_DEFAULT_MSG , if set to 1 , system will use default-*.msg files when user's language msg files can not be found
fixed: anti-lock while cleaning up large amount of un-used memory blocks
fixed: site cat/type permission error , now requiring at least normal level + Read access
fixed: some unable to delete files problem
fixed: possible to perform site nuke while users are reading/writing in the target directory
Version 2.2 build 101
added: new variable %- : the filepath which the client just accessed , without the file name 
added: new variable %+ : the file extension of the file which the client just accessed
added: new event onEveryDay , triggered on the beginning of every new day
Version 2.2 build 91
added: new option in RaidenFTPD.ini , CH_OWN_PASS , if set to 0 , users except root can not change his own password by site chpass command
fixed: site reload does not clean up the allow/ban list in offline dupe db
fixed: online/offline dupe checker bug , when you have too many entries of dupe list , the system could say a non-dupe file as a dupe file
Version 2.2 build 89
fixed: tray icon user count error
Version 2.2 build 88
added: tool tip information , when you put mouse curson on the tray icon it will display current server + user count
added: possible to use user's own *.vfs (virtual file system) instead of server default
added: possible to use group's own *.vfs (virtual file system) instead of server default
            note : read http://www.raidenftpd.com/kb/
Version 2.2 build 75
fixed: automatically set REST counter to zero if upload failed with a file opening error
added: new option in RaidenFTPD.ini , DUPE_MAXROWS , maximum output rows for site srch command
Version 2.2 build 72
added: site index , same as site dupe and srch , to work with CuteFTP
added: S/KEY one time password protection , supports sha1,md4,md5
fixed: APPE (resume upload) is not allowed while OVERWRITE_COMPLETE is 0 and if the file is marked as good
changed: automatically turn off multi-ip rolling if anonymous users is from a proxy
Version 2.2 build 64
added: S/KEY one time password protection , supports md4/md5 , see http://www.raidenftpd.com/kb/kb00000007.html
added: new host languages conversion - site hostconv b2g , g2b (big5 to gb2312) , only available upon request
added: new Japanese Full Help documents
added: new language file , Danish language
changed: does not allow space character in username/group name when you add an user via GUI
fixed: display only primary group for multi group users , in all time top statistics
fixed: allow more than 15 characters in group name (multi-groups) , do not add more than 8 chars in a single group name
Version 2.2 build 58
changed: will not return empty Id3 Tag even the content is empty
fixed: VFS accessing bug for multi-groups users
fixed: chown/chmod bug for multi-groups users
Version 2.2 build 54
added: support for multiple bouncers (which use IDNT command) , BOUNCERIP=ip1,ip2,ip3
fixed: only display primary group for multi groups users , in site who command
changed: user editor , max selection rows increased
Version 2.2 build 48
fixed: 2 server crashing problems while mounting network drives from samba server with illegal directory names
added: multi group support , enter group1,group2,group3 as the group in user editor
added: site authpass [username] [password] , only available for users in 'sitebot' group
Version 2.2 build 45
fixed: max week top rows header , always saying top 10
added: new GUI item in server editor , Excluded IP
added: multiple onSiteCmd events , now having onSiteCmd2 , onSiteCmd3 , onSiteCmd4 
Version 2.2 build 41
fixed: High CPU usage while transfering large binary file in ASCII mode 
changed: max VFS entries expanded to 8192 (was 1024)
added: new site command format , site kick username@IPaddr , site kick username still works
added: tuned for IP*WORKS Secure Tunnel v1.0 (http://www.nsoftware.com) , a SSL FTP protocol bouncer
added: new option in RaidenFTPD.ini
 [DEFAULTS]
 SHOW_TOP_HEADER=0 or 1 (decide to show weektop headers or not)
 STAT_MAX_ROWS=n (how many rows to show in weektop stat files)
 ADDUSER_SELFKILL=0 or 1 (allow selfkill or not , when adding a new user via site 	command)
 SU_CAN_DELUSER=0 or 1 (super users can delete same group users or not , note that he is not allowed to delete any root user)
added: automatically denies upload if free disk space is below 30 mb
added: new GUI item in user editor , possible enable/disable selfkick via !username as login name
added: new site commands for monthly stats , site gpmu , gpmd , mnup , mndn
added: site unfo displays user's IP masks also (for root and user himself only)
added: possible to expand unlimited amount of user languages (see RaidenFTPD.lang)
added: FTP command - FEAT , feature negotiation
added: FTP command - LANG , supporting EN;FR;JA;DE;IT;SV;ES;RU;ZH-TW;ZH-CN
added: host language realtime conversion for pathname and filename (big5<->gb2312 , big5<->s-jis) , *only available upon request 
added: login with ! in front of username , kick all previous sessions under the same account (not applicable to anonymous account)